$().ready(function() {
	$("#audioframe").load(function() {
		
		$jPlayer = document.getElementById('audioframe').contentWindow.$("#jquery_jplayer_1");
		$jPlayer.bind("jPlayer_play", on_play);
		$jPlayer.bind("jPlayer_pause", on_pause);				  
		$jPlayer.bind("jPlayer_seeked", on_seeked);
	});
});

var h = 150,
    w = 420,
    end_pixel = end_point * w,
    start_pixel = start_point * w,
    range_w = end_pixel - start_pixel,
    $jPlayer = null,
    time_pos = 0;

var svg = d3.select('#dendrite')
    .append('svg:svg')
    .attr('height', h)
    .attr('width', w);

var bg = svg.append('svg:g');
var fg = svg.append('svg:g');

bg.append("svg:image")
      .attr("xlink:href", dendrite_image)
      .attr("width", w)
      .attr("height", h)
      .style("cursor", "pointer")
    .on("click", function(){ var x = d3.mouse(this)[0];
			     var t = total_time*((x - start_pixel)/range_w);
			     console.log(t);
			     $jPlayer.jPlayer("play", t);
			   });

fg.selectAll('.pointer')
    .data([[0,1]])
    .enter()
    .append('svg:line')
    .classed('pointer', true)
    .attr('x1',start_pixel)
    .attr('y1',0)
    .attr('x2',start_pixel)
    .attr('y2',h)
    .attr('stroke','#BB3300');

function current_pixel(time_pos) {
    return (time_pos/100.0)*range_w + start_pixel;
}

function play() {
    var pixel = current_pixel(time_pos);
    d3.select('.pointer')
	.attr('x1',pixel)
	.attr('x2',pixel)
      .transition()
	.ease('linear')
	.duration(total_time * ((100 - time_pos) / 100.0) * 1000)
	.attr('x1',end_pixel)
	.attr('x2',end_pixel);
}

function stop() {
    $jPlayer.jPlayer("pause",0);
}

function pause() {
    var pixel = current_pixel(time_pos);
    d3.select('.pointer')
	.transition()
	.duration(0)
	.attr('x1',pixel)
	.attr('x2',pixel);
}

function on_play(event) {
    time_pos = event.jPlayer.status.currentPercentAbsolute;
    play();
}
function on_pause(event) {
    time_pos = event.jPlayer.status.currentPercentAbsolute;
    pause();
}
function on_seeked(event) {
    time_pos = event.jPlayer.status.currentPercentAbsolute;
    console.log('time_pos', time_pos, event.jPlayer.status);
    if (event.jPlayer.status.paused) {
	pause();
    }
    else {
	play();
    }
}