$().ready(function() {
	$("#audioframe").load(function() {
		$jPlayer = document.getElementById('audioframe').contentWindow.$("#jquery_jplayer_1");
		$jPlayer.bind("jPlayer_play", on_play);
		$jPlayer.bind("jPlayer_pause", on_pause);				  
		$jPlayer.bind("jPlayer_seeked", on_seeked);
                console.log("jplayer loaded");
	});
});

var h = 150,
    w = 420,
    image_h = 90,
    end_pixel = end_point * w,
    start_pixel = start_point * w,
    range_w = end_pixel - start_pixel,
    $jPlayer = null,
    time_pos = 0,
    last_status = null;

var x = d3.scale.linear().domain([0, 100]).range([start_pixel, end_pixel]);

var t = d3.scale.linear().domain([0, 100]).range([0, total_time]);

var brush = d3.svg.brush().x(x)
    .on("brushstart", brushStarted)
    .on("brushend", brushEnded);

var timeoutID = null;

function cleanBrush(brush, g) {
    rageRect.attr('stroke', '#777');
    brush.clear();
    g.call(brush);
}

function brushStarted() {
    console.log("-->brushStarted");
    //rangeRect.attr("visible", "none");
    //$jPlayer.jPlayer("pause");
    rageRect.attr('stroke', 'white');
}

function brushEnded() {
    console.log("-->brushEnded");

    var pixel = x(brush.extent()[0]);
    var pixelEnd = x(brush.extent()[1]);

    console.log(pixel,pixelEnd);
    if ((pixelEnd - pixel) > 1) {

    console.log('Brush correcto, se pinta');
  

    d3.select('.pointer')
	.attr('x1',pixel)
	.attr('x2',pixel);

    var time_pos = brush.extent()[0];


    $jPlayer.jPlayer("playHead", time_pos);

    if (timeoutID) {
	clearTimeout(timeoutID);
	console.log('timeout cleared', timeoutID);
    }


	delayedPlay(brush,0);
    
    if (brush.empty()) {
	cleanBrush();
    }

    }
}

function delayedPlay(brush,offset) {
    console.log(offset,brush.extent()[1],brush.extent()[0]);
    if (brush.empty()) return;
    var delay = t(brush.extent()[1]) - t(brush.extent()[0]);

    if (offset != 0) {
//	delay = delay - brush.extent()[0] + offset;
	delay = t(brush.extent()[1]) - t(offset);
    }

    delay = delay/speedFactor;    
    console.log('delayedPlay: ',t(brush.extent()[0]), offset, delay);
    timeoutID = setTimeout(function () {
			       timeoutID = null;
			       if ( ! brush.empty() ) {
				   delayedPlay(brush,0);
				       var time_pos = brush.extent()[0];
				       $jPlayer.jPlayer("playHead", time_pos);
			       }
			       else {
				       clearTimeout(timeoutID);
			       }
			   },
			   delay * 1000
			  );

}

var svg = d3.select('#dendrite')
    .append('svg:svg')
    .attr('height', h)
    .attr('width', w);
    

//--------------------------------------------
//               GRADIENT
//--------------------------------------------

var gradient = svg.append("svg:defs")
  .append("svg:linearGradient")
    .attr("id", "gradient")
    .attr("x1", "0%")
    .attr("y1", "100%")
    .attr("x2", "100%")
    .attr("y2", "100%")
    .attr("spreadMethod", "pad");

gradient.append("svg:stop")
    .attr("offset", "-20%")
    .attr("stop-color", "#EEE")
    .attr("stop-opacity", 1)
  .transition()
    .delay(500)
    .duration(500)
    .attr("offset", "100%");

gradient.append("svg:stop")
    .attr("offset", "-10%")
    .attr("stop-color", "#CCC")
    .attr("stop-opacity", 1)
  .transition()
    .delay(500)
    .duration(500)
    .attr("offset", "110%");

gradient.append("svg:stop")
    .attr("offset", "0%")
    .attr("stop-color", "#EEE")
    .attr("stop-opacity", 1)
  .transition()
    .delay(500)
    .duration(500)
    .attr("offset", "120%")
    .each("end", function(){ rageRect.attr('fill', '#EEE');});



var bg = svg.append('svg:g');
var image_g = svg.append('svg:g');
var fg = svg.append('svg:g');

var rageRect = bg.append("g")
      .attr("class", "x range")
      .append("svg:rect")
      .attr("y", 0)
      .attr("x", start_pixel)
//      .attr("fill", "#EEE")
      .attr("fill", "url(#gradient)")
      .attr("stroke", "#777")
      .attr("height", h)
      .attr("width", range_w);

bg.append("g")
    .on("mouseover", function(){
	if (!brush.empty()) {
            updateTip('Tip: click and drag on this area to move the region of interest');
	} else  {
            updateTip('Tip: click and drag on this area to define a region of interest');
	}
    })

    .on("mouseout", function(){
        updateTip('');})
      .attr("class", "x brush")
      .call(brush)
    .selectAll("rect")
      .attr("y", 0)
      .attr("fill", "#EEE")
      .attr("stroke", "#777")
      .attr("height", h);


image_g.append("svg:image")
      .attr("xlink:href", dendrite_image)
      .attr("width", w)
      .attr("height", image_h)
      .attr("y", (h-image_h)/2)
      .style("cursor", "pointer")
    .on("mouseover", function(){
                   updateTip('Tip: click here to move the cue');})

    .on("mouseout", function(){
                   updateTip('');})
    .on("click", function(){ 
	    var x_click = d3.mouse(this)[0];
	    var time = t(x.invert(x_click));
	    console.log('pixel:', x_click, 'time: ', time);
            time = time / speedFactor;
	    console.log('pixel:', x_click, 'time: ', time);
	    if ((x_click < x(brush.extent()[0])) ||
                (x_click > x(brush.extent()[1]))) {

		cleanBrush(brush, bg);
	    } else {
		clearTimeout(timeoutID);
		delayedPlay(brush,x.invert(x_click));
	    }
    	    $jPlayer.jPlayer("play", time);
	});

fg.selectAll('.pointer')
    .data([[0,1]])
    .enter()
    .append('svg:line')
    .classed('pointer', true)
    .attr('x1',start_pixel)
    .attr('y1',0)
    .attr('x2',start_pixel)
    .attr('y2',h)
    .attr('stroke','#BB3300');


function play() {
    console.log('*** Play',time_pos);
    var pixel = x(time_pos);
    d3.select('.pointer')
      .transition()
	.duration(0)
    	.attr('x1',pixel)
	.attr('x2',pixel)
      .transition()
	.ease('linear')
	.duration((total_time) * ((100 - time_pos) / 100.0) * 1000)
	.attr('x1',end_pixel)
	.attr('x2',end_pixel);
}

function stop() {
    console.log('*** Stop');
    cleanBrush(brush, bg);
    $jPlayer.jPlayer("pause",0);
}

function pause() {
    console.log('*** Pause', time_pos);
    var pixel = x(time_pos);
    d3.select('.pointer')
	.attr('x1',pixel)
	.attr('x2',pixel)
	.transition()
	.duration(0)
	.attr('x1',pixel)
	.attr('x2',pixel);
}

function on_play(event) {
    time_pos = event.jPlayer.status.currentPercentAbsolute;
    last_status = event.jPlayer.status;
    play();
}
function on_pause(event) {
    time_pos = event.jPlayer.status.currentPercentAbsolute;
    last_status = event.jPlayer.status;
    console.log('on_pause', time_pos);
    pause();

}
function on_seeked(event) {
    
    time_pos = event.jPlayer.status.currentPercentAbsolute;
    last_status = event.jPlayer.status;
    console.log('time_pos', time_pos, event.jPlayer.status);
    if (event.jPlayer.status.paused) {
	console.log('seek', time_pos);
	if (time_pos == 0)
	    cleanBrush(brush, bg);
	pause();
    }
    else {
	play();
    }
}
